#ifndef __WAVE_DRAWER_H__
#define __WAVE_DRAWER_H__

#include <wx/wx.h>
#include "WaveFile.h"

class				WaveDrawer
{
 protected:
  long				NumberOfChannels;
  float				**Data;
  long				*DrawData;
  wxSize			size;
  wxBitmap			*Bmp;
  wxMemoryDC			memDC;
  bool				FullDraw;
  bool				UseSettings;

  virtual void			OnPaint(wxPaintDC &dc, wxSize s, wxRegionIterator &region);
  
 public:
  WaveDrawer(const wxSize& s, bool fulldraw = false, bool use_settings = true);
  virtual ~WaveDrawer();
  
  virtual void			SetDrawing(wxSize s);
  virtual void			SetWave(float **data, unsigned long frame_length, long channel_count, wxSize s);
  virtual void			SetWave(WaveFile *w, wxSize s);
  virtual void			SetSize(wxSize s);
  virtual void			SetSize(int x, int y);

  long				StartWavePos;
  long				EndWavePos;
  wxColour			BorderColour;
  WaveFile			*Wave;   
};

#endif/*__WAVE_DRAWER_H__*/
