#ifndef __PITCHSHIFT_H__
#define __PITCHSHIFT_H__

class PitchShift
{
 public:
  PitchShift(long _fftFrameSize, long _osamp, float _sampleRate, float *data, long size);
  ~PitchShift();

  void DoPitchShift(float pitchShift, long numSampsToProcess, 
		    long pos, float *outdata);

  void Fft(float *fftBuffer, long sign);

 protected:
  long fftFrameSize;
  long DataSize;
  long osamp;
  float sampleRate;

  long inFifoLatency;
  long stepSize;
  long fftFrameSize2;
  long fftFrameSizeMul2;
  long fadeZoneLen;
  long gRover;
  long logFftFrameSize;

  double freqPerBin;
  double expct;
  double Inv2PI;

  float *gInFIFO;
  float *gOutFIFO;
  float *gFFTworksp;
  float *gLastPhase;
  float *gSumPhase;
  float *gOutputAccum;
  float *gAnaFreq;
  float *gAnaMagn;
  float *gSynFreq;
  float *gSynMagn;

  double factor;
  int	 step;
  double *cos_table;
  double *sin_table;
  double *atan2_table;

  void PrecalculateFFT(float *data);
};
     
#endif
